
unit Global;

{$N+}

interface

const
     MaxPunkt = 60;

var
   Stop,      // Process stopped
   Spiral     // Tetraspiral
              :boolean;

   Time       //    
              :longint;

   StartFile,
   ThisName   // Name of this file
              :string;

   // Var and Proc 3-D Graphics
   xs,ys,zs,  // koordinat for screen
   x,y,z      // absolut koordinat
              :array[1..MaxPunkt] of extended;
   u,v        // koordinat at display
              :array[1..MaxPunkt] of integer;

   xt,zt,     // 
   uu,vv,xp,yp,zp,j,k,l,
   js,ks,ls,
   f11,f12,f13,f21,f22,f23,f31,f32,f33,
   q,w,e,xl     :extended;

   TypeSpiral,
   u0,v0
              :integer;

   MaxTaons,  // maximal daons from setting
   ii,jj      // koordinat for daons
              :integer;

//   Ann,       // Annigilation
   dt         // differential of timer
              :extended;
//   YAnn       // Flag of annigilation
//              :boolean;

   A1,B1,
   A2,B2,C2,D2,
   A3,B3,C3,D3     // Parametr
              :extended;

   Xo,Xn,
   Yo,Yn,     // Xo - sootvetstvuet x
   Zo,Zn,     // Xn - new koordinat
   Vo,Vn,
   Uo,Un,     // To ze i po skorostjam
   Wo,Wn
              :array[1..MaxPunkt] of extended;

   Dao        // Fact nalichija daona
              :array[1..MaxPunkt] of boolean;

type TaonType = record
//     Ann,       // Annigilation
     dt         // differential of timer
                :extended;
//     YAnn       // Flag of Annigilation
//                :boolean;

   A1,B1,
   A2,B2,C2,D2,
   A3,B3,C3,D3   // Parametr
              :extended;

     Xo,
     Yo,        // Xo - sootvetstvuet x
     Zo,        // Xn - new koordinat
     Vo,
     Uo,        // To ze i po skorostjam
     Wo
                :array[1..MaxPunkt] of extended;
     Dao        // Fact nalichija daona
                :array[1..MaxPunkt] of boolean;
     end;

var  // Files variables
     Taons      :TaonType;
     FTaons     :file of TaonType;
     FTaonsText :text;
     FStartFile :text;

function St(p,g:extended):extended;
procedure fsincos;
procedure Ffsincos;
procedure SaveDataOfTaons;


implementation

function St(p,g:extended):extended;
begin
St:=exp(p*ln(g));
end;

procedure fsincos;//II various j k l
          begin
          f11:=cos(k)*cos(l);
          f12:=-cos(k)*sin(l);
          f13:=sin(k);
          f21:=sin(j)*sin(k)*cos(l)+cos(j)*sin(l);
          f22:=-sin(j)*sin(k)*sin(l)+cos(j)*cos(l);
          f23:=-sin(j)*cos(k);
          f31:=-cos(j)*sin(k)*cos(l)+sin(j)*sin(l);
          f32:=cos(j)*sin(k)*sin(l)+sin(j)*cos(l);
          f33:=cos(j)*cos(k);
          end;
procedure Ffsincos;// For array js, ks ls
          begin
          f11:=cos(ks)*cos(ls);
          f12:=-cos(ks)*sin(ls);
          f13:=sin(ks);
          f21:=sin(js)*sin(ks)*cos(ls)+cos(js)*sin(ls);
          f22:=-sin(js)*sin(ks)*sin(ls)+cos(js)*cos(ls);
          f23:=-sin(js)*cos(ks);
          f31:=-cos(js)*sin(ks)*cos(ls)+sin(js)*sin(ls);
          f32:=cos(js)*sin(ks)*sin(ls)+sin(js)*cos(ls);
          f33:=cos(js)*cos(ks);
          end;

procedure SaveDataOfTaons;
var n:integer;
begin
//   Taons.Ann:=Ann;
//   Taons.YAnn:=YAnn;
   Taons.dt:=dt;
   Taons.A1:=A1;
   Taons.B1:=B1;
   Taons.A2:=A2;
   Taons.B2:=B2;
   Taons.C2:=C2;
   Taons.D2:=D2;
   Taons.A3:=A3;
   Taons.B3:=B3;
   Taons.C3:=C3;
   Taons.D3:=D3;
   for n:=1 to MaxTaons do
       Taons.Dao[n]:=Dao[n];
   for n:=1 to MaxTaons do
       begin
       Taons.Xo[n]:=Xo[n];
       Taons.Yo[n]:=Yo[n];
       Taons.Zo[n]:=Zo[n];
       Taons.Vo[n]:=Vo[n];
       Taons.Uo[n]:=Uo[n];
       Taons.Wo[n]:=Wo[n];
       end;
end;

end.
